﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace TwitterDisplay
{
    public partial class Form1 : Form
    {
        List<TwitterItem> ouritems = new List<TwitterItem>();
        private bool gettingdata = false;
        private Random rand = new Random((int)DateTime.Now.Ticks);

        public Form1()
        {
            InitializeComponent();
        }

        private void btquit_Click(object sender, EventArgs e)
        {
            timerdisplayrandom.Enabled = false;
            timergetnewdata.Enabled = false;
            // ensure we're not getting data
            while (gettingdata)
            {
                Application.DoEvents();
            }
            Application.Exit();
        }

        private void btrefresh_Click(object sender, EventArgs e)
        {
            getdata();
        }
        private void getdata()
        {
            if (Settings.User=="" || Settings.Password=="") return;
            gettingdata = true;
            XmlDocument xdoc = TwitterGetter.GetStatus(Settings.User,Settings.Password);
            XmlNodeList ournodelist = xdoc.GetElementsByTagName("status");

            ouritems.Clear();

            foreach (XmlNode xn in ournodelist)
            {
                TwitterItem ti = new TwitterItem();
                ti.Name = xn["user"]["name"].InnerText;
                string line = xn["text"].InnerText;
                line = line.Substring(Settings.User.Length + 2);
                line = line.Trim();
                ti.Text = line;
                string created = xn["created_at"].InnerText;
                int year = Convert.ToInt32(created.Substring(created.Length-4));
                string monthstring = created.Substring(4,3);
                int month=0;
                switch (monthstring.ToUpper())
                {
                    case "JAN":
                        month = 1;
                        break;
                    case "FEB":
                        month = 2;
                        break;
                    case "MAR":
                        month = 3;
                        break;
                    case "APR":
                        month = 4;
                        break;
                    case "MAY":
                        month = 5;
                        break;
                    case "JUN":
                        month = 6;
                        break;
                    case "JUL":
                        month = 7;
                        break;
                    case "AUG":
                        month = 8;
                        break;
                    case "SEP":
                        month = 9;
                        break;
                    case "OCT":
                        month = 10;
                        break;
                    case "NOV":
                        month = 11;
                        break;
                    case "DEC":
                        month = 12;
                        break;
                    default:
                       
                        break;
                }
                int day = Convert.ToInt32(created.Substring(8, 2));
                int hour = Convert.ToInt32(created.Substring(11, 2));
                int minute = Convert.ToInt32(created.Substring(14, 2));
                int second = Convert.ToInt32(created.Substring(17, 2));
                ti.Created = new DateTime(year, month, day, hour, minute, second);
                ouritems.Add(ti);
            }
            gettingdata = false;
            displaydata();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            setupbasescreen();
            getdata();
            if (Settings.User == "" || Settings.Password == "")
            {
                this.lbtext.Text = "No Twitter User Set";
            }
         }

        private void timerdisplayrandom_Tick(object sender, EventArgs e)
        {
            displaydata();

        }
        private void displaydata()
        {
        if (gettingdata) return;

            if (ouritems.Count == 0) return;
            int whichitem = rand.Next(0,ouritems.Count);
            TwitterItem ti = ouritems[whichitem];
            this.lbtext.Text = ti.Text;
            this.lbfrom.Text = ti.Name + "\r\n" + ti.Created.ToShortDateString()+" "+ti.Created.ToShortTimeString();
        }

        private void timergetnewdata_Tick(object sender, EventArgs e)
        {
            getdata();
        }

        private void btoptions_Click(object sender, EventArgs e)
        {
            frmsettings fset = new frmsettings();
            DialogResult dr = fset.ShowDialog();
            fset.Dispose();
            if (dr == DialogResult.OK)
            {
                this.lbtext.Text = "Getting Posts";
                setupbasescreen();
            }

        }

        private void setupbasescreen()
        {
            this.lbuser.Text = Settings.User;
        }
        
    }
}