﻿using System;


namespace TwitterDisplay
{
    /// <summary>
    /// Summary description for Settings.
    /// </summary>
    public class Settings : IDisposable
    {
        RegistryKey reg = null;
        string kkey = "";//
        private bool disposed = false;

        private static Settings instance = null;

        public static Settings Instance
        {
            get
            {
                if (instance == null) instance = new Settings();
                return instance;
            }
        }

        public Settings()
        {

           
            kkey = @"SOFTWARE\BinaryRefinery\TwitterDisplay";

            for (int i = 0; i < 3; i++)
            {
                reg = Registry.LocalMachine.OpenSubKey(kkey, true);
                if (reg == null)
                {
                    try
                    {
                        Registry.LocalMachine.CreateSubKey(kkey);
                    }
                    catch
                    {
                        System.Threading.Thread.Sleep(100);
                    }
                }
                else
                {
                    break;
                }

            }
            if (reg == null)
                throw new Exception("Could Not Open/Create Reg Key " + kkey);
        }

        public void Dispose()
        {
            Dispose(true);
            GC.SuppressFinalize(this);

        }

        public void Dispose(bool disposing)
        {
            if (disposed) return;
            if (disposing)
            {
                if (reg != null)
                {
                    reg.Close();
                    reg.Dispose();
                    reg = null;
                }
            }

            disposed = true;
        }


       

     
        
        
      
        public static string User
        {
            get
            {
                return Instance.RegReadDefault("user", @"").ToString();
            }
            set
            {
                Instance.RegWrite("user", value);
            }

        }


      

        public static string Password
        {
            get
            {
                return Instance.RegReadDefault("password", "").ToString();
            }
            set
            {
                Instance.RegWrite("password", value);
            }

        }

        private object RegReadDefault(string key, object val)
        {

            if (reg.GetValue(key) == null)
            {
                reg.SetValue(key, val.ToString());
            }
            return reg.GetValue(key);


        }

        private void RegWrite(string key, object val)
        {
            reg.SetValue(key, val.ToString());
        }

    }
}
